/*
 * meter - I mete out time to a child process
 * Copyright (C) 2001  Leon Brooks <leon@cyberknights.com.au>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * with this program (in the file LICENCE); if not, write to
 *	The Free Software Foundation, Inc.,
 *	59 Temple Place - Suite 330,
 *	Boston, MA  02111-1307, USA.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

static pid_t pid;
static char *me, *him;

void bing2 (int discarded) {	/* my name is Linuxo Montoyez */
	kill (pid, SIGKILL);	/* you have SIGKILLed my father, perpare to vi */
	printf ("%s: killing %s (interrupt evidently insufficient)\n", me, him);
}

void bing1 (int discarded) {
	signal (SIGALRM, bing2); /* in case SIGINT ain't enough */
	alarm (2);		/* hit em again in 2 seconds if we still exist */
	kill (pid, SIGINT);	/* spank the child, he will die (Proverbs 23:13 disagrees) */
	printf ("%s: interrupting %s\n", me, him);
}

int main (int argc, char * * argv) {
	long seconds;
	char * p;
	int childstat;

	if (argc < 3) {
		printf ("Useage: %s time command\n"
		  "Copyright (C) 2001 Leon Brooks <leon@cyberknights.com.au>\n"
		  "Use and copy under the GPL (http://www.gnu.org/copyleft/gpl.html) only.\n"
		  "I kill off command (SIGINT, wait 2s, SIGKILL) after time elapses;\n"
		  "time is in seconds, append m/h/d to scale for minutes/hours/days.\n",
		  argv[0]);
		exit (1);
	}
	me = argv [0];
	him = argv [2];
	seconds = strtol (argv [1], &p, 10);
	if (seconds < 1) {
		printf ("%s: invalid number of seconds (%ld), must be >= 0\n",
		  me, seconds);
		exit (1);
	}
	if (seconds > 9999) {
		printf ("%s: %ld is probably more than you wanted, continuing anyway\n",
		  me, seconds);
	}
	if (p && *p) {
		switch (*p++) {
		case 's':
		case 'S':
			break;
		case 'm':
		case 'M':
			seconds *= 60;
			break;
		case 'h':
		case 'H':
			seconds *= (60 * 60);
			break;
		case 'd':
		case 'D':
			seconds *= (60 * 60 * 24);
			break;
		default:
			printf ("%s: %c is not a recognised unit of time\n", me, p[-1]);
			exit (1);
		}
		if (* p) {
			printf ("%s: extra characters after time\n", me);
			exit (1);
		}
	}
	pid = fork ();
	if (pid == 0) {
		execvp (him, argv + 2);
		printf ("%s: failed (%s) to exec timed command (%s)\n",
		  me, sys_errlist [errno], him);
		exit (2);
	} else {
		signal (SIGALRM, bing1);
		alarm (seconds);
		waitpid (pid, &childstat, 0);
		exit (WEXITSTATUS (childstat));
	}
}
/* end */
